build-depends:
- components/nasm.bst
- public-stacks/buildsystem-autotools.bst

depends:
- bootstrap-import.bst
- components/dav1d.bst
- components/fontconfig.bst
- components/freetype.bst
- components/libfdk-aac.bst
- components/lame.bst
- components/libva.bst
- components/libvdpau.bst
- components/mpg123.bst
- components/openal.bst
- components/libpulse.bst
- components/sdl2.bst
- components/aom.bst
- components/gnutls.bst
- components/speex.bst
- components/libtheora.bst
- components/libvorbis.bst
- components/libvpx.bst
- components/opus.bst
- components/vulkan.bst
- components/v4l-utils.bst
- components/xorg-lib-xcb.bst

variables:
  ffmpeg-prefix: '%{prefix}'
  ffmpeg-libdir: '%{libdir}'
  ffmpeg-arch: '%{arch}'
  (?):
  - target_arch == "i686":
      ffmpeg-arch: x86

  audio-encoders: |
    ac3,alac,flac,libfdk_aac,g723_1,mp2,libmp3lame,libopus,libspeex,pcm_alaw,pcm_mulaw,\
    pcm_f32le,pcm_s16be,pcm_s24be,pcm_s16le,pcm_s24le,pcm_s32le,\
    pcm_u8,tta,libvorbis,wavpack,%{extra-aud-enc}

  audio-decoders: |
    adpcm_g722ac3,alac,flac,g723_1,g729,libfdk_aac,libopus,libspeex,\
    mp2,mp3,m4a,pcm_alaw,pcm_mulaw,pcm_f16le,pcm_f24le,pcm_f32be,\
    pcm_f32le,pcm_f64be,pcm_f64le,pcm_s16be,pcm_s16be_planar,pcm_s24be,\
    pcm_s16le,pcm_s16le_planar,pcm_s24le,pcm_s24le_planar,pcm_s32le,\
    pcm_s32le_planar,pcm_s64be,pcm_s64le,pcm_s8,pcm_s8_planar,\
    pcm_u8,pcm_u24be,pcm_u24le,pcm_u32be,pcm_u32be,tta,vorbis,wavpack,\
    %{extra-aud-dec}

  video-encoders: |
    ass,ffv1,libaom_av1,libvpx_vp8,libvpx_vp9,mjpeg_vaapi,rawvideo,\
    theora,vp8_vaapi,%{extra-vid-enc}

  video-decoders: |
    ass,ffv1,mjpeg,mjpegb,libaom_av1,libdav1d,libvpx_vp8,libvpx_vp9,\
    rawvideo,theora,vp8,vp9,%{extra-vid-dec}

  image-formats: |
    bmp,gif,jpegls,png,tiff,webp,%{extra-image-formats}

  hwaccels: |
    vp8_vaapi,mjpeg_vaapi,%{extra-hwaccels}

  muxers: |
    ac3,ass,flac,g722,gif,matroska,mp3,mpegvideo,rtp,ogg,opus,\
    pcm_s16be,pcm_s16le,wav,webm,%{extra-muxers}

  demuxers: |
    aac,ac3,ass,flac,g722,gif,image_jpeg_pipe,image_png_pipe,\
    image_webp_pipe,matroska,mjpeg,mov,mp3,mpegvideo,ogg,pcm_mulaw,\
    pcm_alaw,pcm_s16be,pcm_s16le,rtp,wav,%{extra-demuxers}

  parsers: |
    aac,ac3,flac,mjpeg,mpegaudio,mpeg4video,opus,vp3,vp8,vp9,vorbis,%{extra-parsers}

  filters: |
    crop,scale,overlay,amix,amerge,aresample,format,aformat,fps,transpose,pad,%{extra-filters}

  indevs: |
    v4l2,xcbgrab,%{extra-indevs}

  protocols: |
    crypto,file,pipe,rtp,srtp,rtsp,tcp,udp,unix,%{extra-protocols}

  conf-local: >-
    --prefix="%{ffmpeg-prefix}"
    --libdir="%{ffmpeg-libdir}"
    --disable-debug
    --disable-doc
    --disable-static
    --enable-optimizations
    --enable-shared
    --disable-everything
    --enable-ffplay
    --enable-ffprobe
    --enable-gnutls
    --enable-libaom
    --enable-libdav1d
    --enable-libfdk-aac
    --enable-libmp3lame
    --enable-libfontconfig
    --enable-libfreetype
    --enable-libopus
    --enable-libpulse
    --enable-libspeex
    --enable-libtheora
    --enable-libvorbis
    --enable-libvpx
    --enable-libwebp
    --enable-openal
    --enable-opengl
    --enable-sdl2
    --enable-vulkan
    --enable-zlib
    --enable-libv4l2
    --enable-libxcb
    --enable-vdpau
    --enable-vaapi
    --enable-encoder=%{audio-encoders}
    --enable-encoder=%{video-encoders}
    --enable-decoder=%{audio-decoders}
    --enable-decoder=%{video-decoders}
    --enable-encoder=%{image-formats}
    --enable-decoder=%{image-formats}
    --enable-hwaccel=%{hwaccels}
    --enable-parser=%{parsers}
    --enable-muxer=%{muxers}
    --enable-demuxer=%{demuxers}
    --enable-filter=%{filters}
    --enable-protocol=%{protocols}
    --arch="%{ffmpeg-arch}"

  conf-extra: ''

  extra-aud-enc: ''
  extra-aud-dec: ''
  extra-vid-enc: ''
  extra-vid-dec: ''
  extra-image-formats: ''
  extra-hwaccels: ''
  extra-muxers: ''
  extra-demuxers: ''
  extra-parsers: ''
  extra-filters: ''
  extra-indevs: ''
  extra-protocols: ''

public:
  bst:
    split-rules:
      devel:
        (>):
        - '%{libdir}/libavdevice.so'
        - '%{libdir}/libavcodec.so'
        - '%{libdir}/libswscale.so'
        - '%{libdir}/libpostproc.so'
        - '%{libdir}/libavutil.so'
        - '%{libdir}/libavfilter.so'
        - '%{libdir}/libavformat.so'
        - '%{libdir}/libswresample.so'
        - '%{datadir}/ffmpeg/examples'
        - '%{datadir}/ffmpeg/examples/**'

# ffmpeg is not using autotools, but a configure and Makefile files
config:
  configure-commands:
  - ./configure %{conf-local} %{conf-extra}

sources:
- kind: git_tag
  url: ffmpeg:ffmpeg.git
  track: release/4.3
  ref: n4.3.1-0-g6b6b9e593dd4d3aaf75f48d40a13ef03bdef9fdb
- kind: patch
  path: patches/ffmpeg/aarch64-yuv2rgb-neon-fix-return.patch
